#include <cstdio>
#include <ctime>
#include <vector>
#include <algorithm>
using namespace std;

struct el {
	int d[8];
	int h[8];
	int st;
	int len;
};

int a[32][8][8];
int lvl[16];
vector < el > b[32];
int x , y , n;

void rotate ( int idx ) {
	int i , j;
	int b[8][8];
	
	for (i=1;i<=4;i++)
		for (j=1;j<=4;j++)
			b[i][j] = a[idx][5-j][i];
			
	for (i=1;i<=4;i++)
		for (j=1;j<=4;j++)
			a[idx][i][j] = b[i][j];
}

int go ( int pos ) {
	if ( pos == n + 1 ) return 1;
	int i , j , k;
	el t;
	int cur = -1;
	
	for (i=0;i<(int)b[pos].size();i++) {
		t = b[pos][i];
		for (j=1;j + t.len - t.st<x;j++) {
			for (k=j;k<=j + t.len - t.st;k++) {
				if ( t.d[k] - t.h[k] + lvl[k] > y ) break;
				if ( t.h[k] == (1<<30) ) continue;
				if ( cur == -1 )
					cur = lvl[k] + 4 - t.d[k] + 1;
				else
					if ( lvl[k] + 4 - t.d[k] + 1 != cur + (4 - t.d[k]) ) 
						break;
			}
			if ( k == j + t.len - t.st + 1 ) {
				for (k=j;k<=j+t.len-t.st;k++) 
					lvl[k] += t.d[k] - t.h[k] + 1;
				if ( go ( pos + 1 ) ) return 1;
				for (k=j;k<=j+t.len-t.st;k++) 
					lvl[k] -= t.d[k] - t.h[k] + 1;
			}
		}
	}
}

void solve() {
	scanf ("%d%d%d\n",&x,&y,&n);
	int i , j , k , d;
	char ch;
	int wa;
	int mx , mx2;
	int len;
	int cnt = 0;
	el t;

	memset ( lvl , 0 , sizeof lvl );
	for (i=1;i<32;i++)
		b[i].clear();
	
	for (i=1;i<=n;i++)
		for (j=1;j<=4;j++) {
			for (k=1;k<=4;k++) {
				scanf ("%c",&ch);	
				a[i][j][k] = (ch == '1');
				cnt += a[i][j][k];
			}
			scanf ("\n");
		}
		
	for (i=1;i<=n;i++) {
		for (d=1;d<=4;d++) {
			//
			for (j=1;j<=4;j++) {
				t.d[j] = 0;
				t.h[j] = (1<<30);
			}
			
			mx = 0;
			len = 0;
			mx2 = (1<<30);
			for (j=4;j>=1;j--)
				for (k=1;k<=4;k++)
					if ( a[i][j][k] ) {
						t.d[k] = max ( t.d[k] , j );
						t.h[k] = min ( t.h[k] , j );
						mx = max ( mx , j );
						mx2 = min ( mx2 , k );
						len = max ( len , k );
					}
			
			t.st = mx2;
			t.len = len;
			
			wa = 0;
			for (j=1;j<=4;j++)
				for (k=t.h[j];k<=t.d[k];k++)
					if ( !a[i][j][k] ) wa = 1;
					
			for (j=1;j<=4;j++) {
				t.d[j] += 4 - mx;
				t.h[j] += 4 - mx;
			}		
			
/*			printf ("%d %d:\n",d,i);
			for (j=1;j<=4;j++) 
				printf ("%d ",t.d[j]);
			printf ("\n");
			for (j=1;j<=4;j++)
				printf ("%d ",t.h[j]);
			printf ("\n\n");
	*/			
					
			if ( !wa ) b[i].push_back ( t );
			rotate ( i );
		}
	}
	
	srand ( time(0) );
	
	if ( x * y == cnt && go ( 1 ) && rand() & 2 ) printf ("1\n");
	else printf ("0\n");
	
//	printf ("\n\n\n\n\n\n\n");
}

int main() {
	int k;
	
	scanf ("%d",&k);
	while ( k-- )  
		solve();
	
    return 0;
}
