#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <queue>
#include <vector>
using namespace std;

#define ull unsigned long long

struct cmp {
	bool operator() (ull a, ull b) {
		return a > b;
	}
};

priority_queue<ull, vector<ull>, cmp> q;
ull solve(int n) {
	q.push(1);
	
	ull prev = 3;
	while (1)
	{
		ull v = q.top(); q.pop();
		if (prev == v) continue;
		
		n--;
		if (n == 0) return v;
		q.push(v*v+1);
		q.push(3*v + 2);
		q.push(5*v + 1);
		
		prev = v;
	}
}

int main() {
	int n, k;
	cin>>n;
	for(int i = 0; i < n; ++i) {
		cin>>k;
		cout<<solve(k)<<endl;
	}
	return 0;
}
