#include <iostream>
#include <cstdio>
using namespace std;

int T;

int days[] = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

void work(int X, string s)
{
 for (;;)
 {
  bool ready = true;
  for (int i = 0; i < s.size(); i++)
   if (s[i] == '/' || s[i] == '\\' || s[i] == '<' || s[i] == '>')
   {
    ready = false;
    if (s[i] == '/') s.erase(i, 3); else
    if (s[i] == '\\') s.erase(i - 2, 3); else
    if (s[i] == '<') s.erase(i - 3, 4); else
    if (s[i] == '>') s.erase(i, 4);
    break;
   }
  if (ready) break;
 }
 s.erase(s.size() - 1, 1);
 int hash = 0;
 for (int i = 0; i < s.size(); i++)
 {
  hash = hash * X + (int)s[i];
  hash %= 366;
 }
 //cout << hash << endl;
 int month = 1, day = 1, br = -1;
 
 for (;;)
 { 
  br++;
  if (br == hash) { printf("%02d.%02d.2008", day, month); break; }
  day++;
  if (day > days[month - 1]) { day = 1; month++; }
 }
 
 sort(s.begin(), s.end());
 hash = 0;
 for (int i = 0; i < s.size(); i++)
 {
  hash = hash * X + (int)s[i];
  hash %= 86400;
 }
 
 int hour = hash / 3600;
 hash -= hour * 3600;
 int minu = hash / 60;
 hash -= minu * 60;
 int sec = hash;
 
 printf(" %02d:%02d:%02d\n", hour, minu, sec);
}

int main()
{
 cin >> T;
 
 for (int t = 0; t < T; t++)
 {
  int X; string S;
  cin >> X;
  cin >> S;
  work(X, S);
 }
 
 return 0;
}
