#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

const int MOD = 366;
const int MOD2 = 86400;

int mon[] = { 0 , 31 , 29 , 31 , 30 , 31 , 30 , 31 , 31 , 30 , 31 , 30 , 31 };

char s[128];
int used[128];
vector < char > vec;

void pr ( int x ) {
	if ( x <= 9 )
		printf ("0");
	printf ("%d",x);
}

void solve() {
	int x;
	int n;
	int i , j;
	int t = 0;
	int pow;
	int cur;
	int pol = 1;
	int p;
	
	scanf ("%d",&x);
	scanf ("%s",s);
	
	memset ( used , 0 , sizeof used );
	vec.clear();
	n = (int)strlen ( s );
	-- n;
	
	for (i=0;i<n;i++)
		if ( !isalpha ( s[i] ) && !used[i] ) {
			if ( s[i] == '/' ) {
				p = 3;
				for (j=i;j<n;j++) {
					if ( !used[j] ) {
						used[j] = 1;
						-- p;
					}
					if ( !p ) break;
				}
			}
			if ( s[i] == '\\' ) {
				p = 3;
				for (j=i;j>=0;j--) {
					if ( !used[j] ) {
						used[j] = 1;
						-- p;
					}
					if ( !p ) break;
				}
			}
			if ( s[i] == '>' ) {
				p = 4;
				for (j=i;j<n;j++) {
					if ( !used[j] ) {
						used[j] = 1;
						-- p;
					}
					if ( !p ) break;
				}
			}
			if ( s[i] == '<' ) {
				p = 4;
				for (j=i;j>=0;j--) {
					if ( !used[j] ) {
						used[j] = 1;
						-- p;
					}
					if ( !p ) break;
				}
			}
		}
	
	for (i=0;i<n;i++)
		t += !used[i];

	for (i=0;i<n;i++)
		if ( !used[i] ) {
			vec.push_back ( s[i] );
//			printf ("%c",s[i]);
			pow = 1;
			for (j=1;j<t;j++)
				pow = (pow * x) % MOD;
			--t;
			pol = (pol + ((s[i]*pow) % MOD)) % MOD;
		}
	sort ( vec.begin() , vec.end() );
//	printf ("\n");
		
//	printf ("%d\n",pol);

	cur = pol;
	for (i=1;i<=12;i++) {
		if ( cur - mon[i] > 0 ) cur -= mon[i];
		else
			break;
	}
			
	pr ( cur );
	printf (".");
	pr ( i );
	printf (".2008 ");
	
	pol = 0;
	for (i=0;i<(int)vec.size();i++) {
		pow = 1;
		for (j=i+1;j<(int)vec.size();j++)
			pow = (pow * x) % MOD2;
		pol = (pol + ((vec[i]*pow) % MOD2)) % MOD2;
	}
	
	pr ( pol / 3600 );
	pol %= 3600;
	printf (":");
	pr ( pol / 60 );
	printf (":");
	pol %= 60;
	pr ( pol );
	
	printf ("\n");
}
int main() {
	int k;
	
	scanf ("%d",&k);
	while ( k-- ) 
		solve();
	
    return 0;
}
