#include <cstdio>
#include <algorithm>
using namespace std;

int a[1024][1024];
int sum[1024][1024];

void solve() {
	int n;
	int i , j , k , d;
	int ans = 0;
	
	scanf ("%d",&n);
	
	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++)
			scanf ("%d",&a[i][j]);
			
	memset ( sum , 0 , sizeof sum );
	
	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++)
			sum[i][j] = sum[i][j-1] + sum[i-1][j] - sum[i-1][j-1] + a[i][j];
			
	for (i=1;i<=n;i++)
		for (j=1;j<=n;j++) {
			if ( a[i][j] < 0 ) continue;
			for (k=j;k<=n;k++) {
				if ( sum[i][k] - sum[i][j-1] < 0 ) break;
				for (d=i;d<=n;d++) 
					if ( sum[d][k] - sum[i-1][k] - sum[d][j-1] + sum[i-1][j-1] < 0 ) break;
					else
						ans = max ( ans , sum[d][k] - sum[i-1][k] - sum[d][j-1] + sum[i-1][j-1] ); 
			}
						
			for (k=i;k<=n;k++) {
				if ( sum[k][j] - sum[i][j-1] < 0 ) break;
				for (d=j;d<=n;d++) 
					if ( sum[d][k] - sum[i-1][d] - sum[k][j-1] + sum[i-1][j-1] < 0 ) break;
					else
						ans = max ( ans , sum[d][k] - sum[i-1][d] - sum[k][j-1] + sum[i-1][j-1] ); 
			}
		}
	
	printf ("%d\n",ans);
}

int main() {
	int k;
	
	scanf ("%d",&k);
	while ( k-- ) 
		solve();
	
    return 0;
}
