#include <cstdio>
#include <string>
#include <iostream>

using namespace std;

int d[] = {31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

int n, x, fsize;
char pattern[128], final[128];


long long power(long long x, long long y, long long mod)
{
	if (!y) return 1;
	if (y == 1) return x%mod;
	if (y & 1) return x*power(x, y-1, mod);
	else 
	{
	  int temp=power(x, y/2,mod);
	  return (temp*temp)%mod;
	}
}

int getDay (int i)
{
	int m = 0;
	while (d[m] < i)
	{
		i -= d[m];
		++m;
	}
	printf("%02d.%02d.2008 ", i, m + 1);
//	cout << m + 1 << " " << i << endl;
}
void solve()
{
	long long P = 0;
	for (int i=0; i<fsize; ++i)
	{
		long long g = final[i];
	 	P+=g*power(x, fsize-1-i,366);
	 	P%=366;
	}
	P%=366;
	getDay(P + 1);
//	while (
	sort(final, final+fsize);
	long long G = 0;
	for (int i=0; i<fsize; ++i)
	{
		long long g= final[i];
	 	G+=g*power(x, fsize-1-i,86400);
	 	G%=86400;
	}
	G%=86400;
	int H = G / 3600; G -= H * 3600;
	int M = G / 60; G -= M * 60;
	int S = G;
	printf("%02d:%02d:%02d\n", H, M, S);
}
/*
void testing ()
{
	for (int i = 1; i <= 100; ++i)
		getDay (i);
}
*/
void read()
{
	scanf("%d", &n);
	for (int i=0; i<n; ++i)
	{
		scanf("%d", &x);
		scanf("%s", pattern);
		fsize=0;
		int size=strlen(pattern);
		for (int j=0; j<size;)
		{
			if (pattern[j] == '.') break;
			if (pattern[j] == '/')
				j+=3;
			else if (pattern[j] == '\\')
				{
					++j;
					if (fsize<2) fsize=0;
					else fsize-=2;
				}
			else if (pattern[j] == '>')
				j+=4;
			else if (pattern[j] == '<')
				 {
					 ++j;
					 if (fsize < 3) fsize=0;
					 else fsize-=3;
				} 
			else
			{
				final[fsize++]=pattern[j++];
			}
		}
	solve();
	}
}

int main()
{
	read();
return 0;
}
