#include <cstdio>
#include <iostream>
#include <memory.h>
#include <ctime>
#include <algorithm>
using namespace std;

const int MAX=1024;

time_t init=clock(), start;

int n;
int A[MAX][MAX];
int r[MAX][MAX];
int dp[MAX][MAX];

int main() {
    int t, v, i, j, p, q, ans, w;
    int perm[MAX];
    
    for (i=1; i<MAX; i++) perm[i]=i;
    
    cin >>t;
    for (v=0; v<t; v++) {
          start = clock();
          
          memset (r,0,sizeof(r));
          cin >> n;
          ans=-1000000000;
          for (i=1; i<=n; i++)
             for (j=1; j<=n; j++) {
                scanf ("%d", &A[i][j]);
                r[i][j] = r[i][j-1] + A[i][j];
             }
             
          double T = 45.0*CLOCKS_PER_SEC - (clock()-init);
          
          random_shuffle (perm+1,perm+n+1);

          for (w=1; w<=n; w++) {
               p = perm[w];
               if ( clock()-start > T/(t-v) ) break;
               memset (dp,0,sizeof(dp));
               for (i=1; i<=n; i++)
                    for (j=1; j<=n; j++) {
                          //dp[i][j] = max( dp[i-1][j] + r[i][j] - r[i][j-p], r[i][j] - r[i][j-p] );
                          dp[i][j] = (dp[i-1][j]>0?dp[i-1][j]:0) + r[i][j] - r[i][j-p];
                          
                           //cout << i << " " << j << " " << dp[i][j] << endl;
                          
                          if (dp[i][j]>ans) ans=dp[i][j];
                    }
          }       
          
          cout << ans << "\n";
    }
    return 0;
}
