#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;

char s[32][32];
int found[1024];

int low ( char ch ) {
	if ( isalpha ( ch ) ) {
		if ( isupper ( ch ) ) return ch;
		return ch - 'a' + 'A';
	}
	return ch;
}

void solve() {
	int n;
	int i , j;
	int sz;
	int ans = 0;
	int cur;
	
	scanf ("%d",&n);
	
	for (i=1;i<=n;i++)
		scanf ("%s",s[i]);
		
	for (i=1;i<=n;i++) {
		memset ( found , 0 , sizeof found );
		
		sz = (int)strlen(s[i]);
		for (j=0;j<sz;j++) {
			if ( found[ low(s[i][j]) ] ) break;
			found[ low(s[i][j]) ] = j;
		}
		
		cur = j + found[ low(s[i][j]) ] + 2;
		
		memset ( found , 0 , sizeof found );
		
		for (j=sz-1;j>=0;j--) {
			if ( found[ low(s[i][j]) ] ) break;
			found[ low(s[i][j]) ] = j;
		}
		
		cur += j + found[ low(s[i][j]) ] + 2;
		
		ans = max ( ans , cur );
	}
	
	printf ("%d\n",ans);
}

int main() {
	int k;
	
	scanf ("%d",&k);
	while ( k-- ) 
		solve();
	
    return 0;
}
