#include <cstdio>
#include <cstring>

int scan(char* str, char c, int pos, int dir) {
	for(int i = pos; i >= 0 && str[i]; i += dir) {
		if(str[i] == c)
			return i;
	}
	return -1;
}

int solve(char* str) {
	int len = strlen(str), la, lb, ra, rb, c;
	for(int i = len-1; i >= 0; --i) {
		c = scan(str, str[i], i-1, -1);
		if(c != -1) {
			la = i;
			lb = c;
		}
	}
	for(int i = 0; i < len; ++i) {
		c = scan(str, str[i], i+1, +1);
		if(c != -1) {
			ra = i;
			rb = c;
		}
	}
	return la+lb+ra+rb+4;
}

char str[32];
int main() {
	int tests;
	scanf("%d", &tests);
	for(int i = 0; i < tests; ++i) {
		int n, c, m = -1;
		scanf("%d", &n);
		for(int i = 0; i < n; ++i) {
			scanf("%s", str);
			c = solve(str);
			if(c > m)
				m = c;
		}
		printf("%d\n", m);
	}
	return 0;
}
