
#include <cstdio>
using namespace std;

int n;
int col [1024][1024];
int num [1024][1024];

void solve ()
{
	int i, j, k;
	for (i = 0; i < n; ++i)
	{
		col [i][0] = 0;
		for (j = 1; j <= n; ++j)
			col [i][j] = col [i][j - 1] + num [j - 1][i];
	}
	
	int cur;
	int res = -200000000;
	for (i = 0; i < n; ++i)
		for (j = i; j < n; ++j)
		{
			cur = 0;
			for (k = 0; k < n; ++k)
			{
				cur += col [k][j + 1] - col [k][i];
				if (res < cur)
					res = cur;
				if (cur < 0)
					cur = 0;
			}
		}
	printf ("%d\n", res);
}
int main ()
{
	int tests;
	scanf ("%d", &tests);
	while (tests > 0)
	{
		--tests;
		scanf ("%d", &n);
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				scanf ("%d", &num [i][j]);
		solve ();
	}
	return 0;
}
